'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getType = getType;
exports.groupByType = groupByType;
/**
 * Created by andrew on 4/21/16.
 */

/**
 *
 * @type {{isFunction(),isArray(),isBoolean(),isNumber(),isString(),isUndefined(),isObject()}}
 */
var type = {};
exports.default = type;


var fullName = void 0,
    originalName = void 0; // PhantomJS bug

var __toString = Object.prototype.toString,
    _undef = undefined,
    sourceTypes = [true, 1, [], 'str', function () {}, _undef, {}],
    classNamePattern = /\s+(\w+)]/;

for (var i = 0, maxI = sourceTypes.length; i < maxI; i++) {
  fullName = (originalName = __toString.call(sourceTypes[i])).replace('DOMWindow', 'Undefined'); // PhantomJS bug
  type['is' + fullName.match(classNamePattern)[1]] = getTestFor(originalName);
}

function getType(input) {
  return __toString.call(input).replace('DOMWindow', 'Undefined').match(classNamePattern)[1].toLowerCase();
}

function groupByType(args) {
  return args.reduce(function (memo, arg) {
    memo[getType(arg)] = arg;
    return memo;
  }, {});
}

function getTestFor(fullName) {
  return function (val) {
    return __toString.call(val) === fullName;
  };
}